Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/Core.cs	(revision 4042)
@@ -334,29 +334,42 @@
       if (e.Result.StatusMessage != ApplicationConstants.RESPONSE_COMMUNICATOR_NO_JOBS_LEFT) {
         Logger.Info("Received new job with id " + e.Result.Job.Id);      
-        bool sandboxed = false;
-        List<byte[]> files = new List<byte[]>();
+        bool sandboxed = false;        
         Logger.Debug("Fetching plugins for job " + e.Result.Job.Id);
-        foreach (CachedHivePluginInfoDto plugininfo in PluginCache.Instance.GetPlugins(e.Result.Job.PluginsNeeded))
-          files.AddRange(plugininfo.PluginFiles);
+
+        PluginCache.Instance.PreparePlugins(e.Result.Job.PluginsNeeded);
+
+//        foreach (CachedHivePluginInfoDto plugininfo in PluginCache.Instance.GetPlugins(e.Result.Job.PluginsNeeded))
+  //        files.AddRange(plugininfo.PluginFiles);
         Logger.Debug("Plugins fetched for job " + e.Result.Job.Id);
-        AppDomain appDomain = HeuristicLab.PluginInfrastructure.Sandboxing.SandboxManager.CreateAndInitSandbox(e.Result.Job.Id.ToString(), files);
-        appDomain.UnhandledException += new UnhandledExceptionEventHandler(appDomain_UnhandledException);
-        lock (engines) {
-          if (!jobs.ContainsKey(e.Result.Job.Id)) {
-            jobs.Add(e.Result.Job.Id, e.Result.Job);
-            appDomains.Add(e.Result.Job.Id, appDomain);
-            Logger.Debug("Creating AppDomain");
-            Executor engine = (Executor)appDomain.CreateInstanceAndUnwrap(typeof(Executor).Assembly.GetName().Name, typeof(Executor).FullName);
-            Logger.Debug("Created AppDomain");
-            engine.JobId = e.Result.Job.Id;
-            engine.Queue = MessageQueue.GetInstance();
-            Logger.Debug("Starting Engine for job " + e.Result.Job.Id);
-            engine.Start(e.Data);
-            engines.Add(e.Result.Job.Id, engine);
-
-            ClientStatusInfo.JobsFetched++;
-
-            Logger.Info("Increment FetchedJobs to:" + ClientStatusInfo.JobsFetched);
+        try {
+          AppDomain appDomain =
+            HeuristicLab.PluginInfrastructure.Sandboxing.SandboxManager.CreateAndInitSandbox(
+              e.Result.Job.Id.ToString(), null);
+          appDomain.UnhandledException += new UnhandledExceptionEventHandler(appDomain_UnhandledException);
+          lock (engines) {
+            if (!jobs.ContainsKey(e.Result.Job.Id)) {
+              jobs.Add(e.Result.Job.Id, e.Result.Job);
+              appDomains.Add(e.Result.Job.Id, appDomain);
+              Logger.Debug("Creating AppDomain");
+              Executor engine =
+                (Executor)
+                appDomain.CreateInstanceAndUnwrap(typeof (Executor).Assembly.GetName().Name, typeof (Executor).FullName);
+              Logger.Debug("Created AppDomain");
+              engine.JobId = e.Result.Job.Id;
+              engine.Queue = MessageQueue.GetInstance();
+              Logger.Debug("Starting Engine for job " + e.Result.Job.Id);
+              engine.Start(e.Data);
+              engines.Add(e.Result.Job.Id, engine);
+
+              ClientStatusInfo.JobsFetched++;
+
+              Logger.Info("Increment FetchedJobs to:" + ClientStatusInfo.JobsFetched);
+            }
           }
+        } catch(Exception exception) {
+          Logger.Error("Creating the Appdomain and loading the job failed for job " + e.Result.Job.Id);
+          Logger.Error("Error thrown is: ", exception);
+          CurrentlyFetching = false;
+          KillAppDomain(e.Result.Job.Id);
         }
       } else
@@ -482,10 +495,14 @@
       lock (engines) {
         try {
-          engines[id].Dispose();  
-          appDomains[id].UnhandledException -= new UnhandledExceptionEventHandler(appDomain_UnhandledException);
-          AppDomain.Unload(appDomains[id]);
-          appDomains.Remove(id);
+          if(engines.ContainsKey(id))
+            engines[id].Dispose();
+          if (appDomains.ContainsKey(id)) {
+            appDomains[id].UnhandledException -= new UnhandledExceptionEventHandler(appDomain_UnhandledException);
+            AppDomain.Unload(appDomains[id]);
+            appDomains.Remove(id);
+          }
           engines.Remove(id);
           jobs.Remove(id);
+          GC.Collect();
         }
         catch (Exception ex) {
Index: /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/PluginCache.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/PluginCache.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Client.Core/3.2/PluginCache.cs	(revision 4042)
@@ -8,4 +8,5 @@
 using HeuristicLab.Hive.Contracts.BusinessObjects;
 using HeuristicLab.Tracing;
+using System.IO;
 
 namespace HeuristicLab.Hive.Client.Core {
@@ -67,4 +68,25 @@
     }
 
+
+    internal void PreparePlugins(List<HivePluginInfoDto> requiredPlugins) {
+      List<HivePluginInfoDto> missingPlugins = new List<HivePluginInfoDto>();
+      foreach (HivePluginInfoDto requiredPlugin in requiredPlugins) {
+        if(ApplicationManager.Manager.Plugins.Count(ipd => ipd.Version.Major == requiredPlugin.Version.Major && ipd.Version.Minor >= requiredPlugin.Version.Minor) == 0) {
+          missingPlugins.Add(requiredPlugin);             
+        }
+      }
+
+      Logger.Debug("Requesting missing plugins");
+      List<CachedHivePluginInfoDto> receivedPlugins = WcfService.Instance.RequestPlugins(missingPlugins);
+      Logger.Debug("Requested missing plugins");
+
+      foreach (CachedHivePluginInfoDto receivedPlugin in receivedPlugins) {
+        foreach (HivePluginFile hpf in receivedPlugin.PluginFiles) {
+          Logger.Info("writing file " + hpf.Name);
+          File.WriteAllBytes("C:\\temp\\" + hpf.Name.Split('\\').Last(), hpf.BinaryFile);
+        }        
+      }
+
+    }
   }
 }
Index: /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/CachedHivePluginInfoDto.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/CachedHivePluginInfoDto.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/CachedHivePluginInfoDto.cs	(revision 4042)
@@ -25,4 +25,5 @@
 using HeuristicLab.Hive.Contracts.BusinessObjects;
 using System.Runtime.Serialization;
+using HeuristicLab.PluginInfrastructure.Manager;
 
 namespace HeuristicLab.PluginInfrastructure {
@@ -30,13 +31,13 @@
   [Serializable]
   public class CachedHivePluginInfoDto : HivePluginInfoDto {
-
-    private List<byte[]> pluginFiles = new List<byte[]>();
+    
     /// <summary>
     /// stores the plugin files in a list of byte arrays
     /// </summary>
     [DataMember]
-    public List<byte[]> PluginFiles {
-      get { return pluginFiles; }
-      set { pluginFiles = value; }
+    public List<HivePluginFile> PluginFiles { get; set; }
+
+    public CachedHivePluginInfoDto() {
+      PluginFiles = new List<HivePluginFile>();
     }
   }
Index: /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/HivePluginFile.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/HivePluginFile.cs	(revision 4042)
+++ /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/HivePluginFile.cs	(revision 4042)
@@ -0,0 +1,21 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Hive.Contracts.BusinessObjects {
+  [Serializable]
+  [DataContract]
+  public class HivePluginFile {
+    [DataMember]
+    public byte[] BinaryFile { get; set; }
+    [DataMember]
+    public String Name { get; set; }  
+
+    public HivePluginFile(byte[] binaryFile, String name) {
+      BinaryFile = binaryFile;
+      Name = name;
+    }
+  }
+}
Index: /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/HivePluginInfoDto.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/HivePluginInfoDto.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/BusinessObjects/HivePluginInfoDto.cs	(revision 4042)
@@ -37,5 +37,5 @@
 
     [DataMember]
-    public String Version { get; set; }
+    public Version Version { get; set; }
 
     [DataMember]
Index: /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/HeuristicLab.Hive.Contracts-3.2.csproj
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/HeuristicLab.Hive.Contracts-3.2.csproj	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/HeuristicLab.Hive.Contracts-3.2.csproj	(revision 4042)
@@ -91,4 +91,5 @@
     <Compile Include="BusinessObjects\CachedHivePluginInfoDto.cs" />
     <Compile Include="BusinessObjects\ClientGroupDto.cs" />
+    <Compile Include="BusinessObjects\HivePluginFile.cs" />
     <Compile Include="BusinessObjects\ResourceDto.cs" />
     <Compile Include="BusinessObjects\SerializedJob.cs" />
@@ -139,4 +140,8 @@
       <Name>HeuristicLab.PluginInfrastructure</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Tracing\3.2\HeuristicLab.Tracing-3.2.csproj">
+      <Project>{EE2034D9-6E27-48A1-B855-42D45F69A4FC}</Project>
+      <Name>HeuristicLab.Tracing-3.2</Name>
+    </ProjectReference>
   </ItemGroup>
   <ItemGroup>
Index: /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IExecutionEngineFacade.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IExecutionEngineFacade.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IExecutionEngineFacade.cs	(revision 4042)
@@ -37,5 +37,5 @@
     Response RequestSnapshot(Guid jobId);
     [OperationContract]
-    ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId, bool requested);
+    ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId, bool requested, bool snapshot);
     [OperationContract]
     Response AbortJob(Guid jobId);    
Index: /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IJobManager.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IJobManager.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/Interfaces/IJobManager.cs	(revision 4042)
@@ -48,5 +48,5 @@
     ResponseObject<JobDto> GetLastJobResultOf(Guid jobId);
     [OperationContract]
-    ResponseObject<SerializedJob> GetLastSerializedJobResultOf(Guid jobId, bool requested);
+    ResponseObject<SerializedJob> GetLastSerializedJobResultOf(Guid jobId, bool requested, bool snapshot);
     [OperationContract]
     ResponseList<JobResult> GetAllJobResults(Guid jobId);
Index: /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/MultiStream.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/MultiStream.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Contracts/3.2/MultiStream.cs	(revision 4042)
@@ -6,4 +6,5 @@
 using System.IO;
 using System.Collections;
+using HeuristicLab.Tracing;
 
 namespace HeuristicLab.Hive.Contracts {
@@ -102,9 +103,10 @@
 
     protected override void Dispose(bool disposing) {
-      if (!disposing) {
+      //if (!disposing) {
         foreach (Stream s in this.streamList) {
+          Console.WriteLine("DISPOSING STREAM");
           s.Dispose();
         }
-      }
+      //}
       
       base.Dispose(disposing);
Index: /branches/3.2/sources/HeuristicLab.Hive.Engine/3.2/HiveEngine.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Engine/3.2/HiveEngine.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Engine/3.2/HiveEngine.cs	(revision 4042)
@@ -136,5 +136,5 @@
           lock (locker) {
             Logger.Debug("HiveEngine: Results-polling - GetLastResult");
-            response = executionEngineFacade.GetLastSerializedResult(jobId, false);
+            response = executionEngineFacade.GetLastSerializedResult(jobId, false, false);
             Logger.Debug("HiveEngine: Results-polling - Server: " + response.StatusMessage + " success: " + response.Success);
             // loop while 
@@ -144,5 +144,5 @@
             // 4. the result that we get from the server is a snapshot and not the final result
             if (abortRequested) return;
-            if (response.Success && response.Obj != null) {
+              if (response.Success && response.Obj != null && response.StatusMessage != ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE) {
               Logger.Debug("HiveEngine: Results-polling - Got result!");
               restoredJob = (Job)PersistenceManager.RestoreFromGZip(response.Obj.SerializedJobData);
@@ -171,5 +171,5 @@
           // job is finished already
           Logger.Debug("HiveEngine: Abort - GetLastResult(false)");
-          response = executionEngineFacade.GetLastSerializedResult(jobId, false);
+          response = executionEngineFacade.GetLastSerializedResult(jobId, false, false);
           Logger.Debug("HiveEngine: Abort - Server: " + response.StatusMessage + " success: " + response.Success);
         } else {
@@ -179,5 +179,5 @@
             Thread.Sleep(SNAPSHOT_POLLING_INTERVAL_MS);
             Logger.Debug("HiveEngine: Abort - GetLastResult(true)");
-            response = executionEngineFacade.GetLastSerializedResult(jobId, true);
+            response = executionEngineFacade.GetLastSerializedResult(jobId, false, true);
             Logger.Debug("HiveEngine: Abort - Server: " + response.StatusMessage + " success: " + response.Success);
             retryCount++;
@@ -264,5 +264,5 @@
           new HivePluginInfoDto();
         pluginInfo.Name = uniquePlugin.Name;
-        pluginInfo.Version = uniquePlugin.Version.ToString();
+        pluginInfo.Version = uniquePlugin.Version;
         pluginInfo.BuildDate = uniquePlugin.BuildDate;
         pluginsNeeded.Add(pluginInfo);
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/JobAdapter.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/JobAdapter.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/JobAdapter.cs	(revision 4042)
@@ -369,5 +369,5 @@
           //first check if pluginInfo already exists in the db
           HivePluginInfoDto found = PluginInfoAdapter.GetByNameVersionBuilddate(
-            pluginInfo.Name, pluginInfo.Version, pluginInfo.BuildDate);
+            pluginInfo.Name, pluginInfo.Version.ToString(), pluginInfo.BuildDate);
           if (found != null) {
             pluginInfo.Id = found.Id;
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/PluginInfoAdapter.cs
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/PluginInfoAdapter.cs	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.ADODataAccess/3.2/PluginInfoAdapter.cs	(revision 4042)
@@ -27,5 +27,5 @@
         row.PluginId = pluginInfo.Id;
         row.Name = pluginInfo.Name;
-        row.Version = pluginInfo.Version;
+        row.Version = pluginInfo.Version.ToString();
         row.BuildDate = pluginInfo.BuildDate;
 
@@ -48,5 +48,5 @@
 
         if (!row.IsVersionNull()) {
-          pluginInfo.Version = row.Version;
+          pluginInfo.Version = new Version(row.Version);
         } else {
           pluginInfo.Version = null;
Index: /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HeuristicLab.Hive.Server.Console-3.2.csproj
===================================================================
--- /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HeuristicLab.Hive.Server.Console-3.2.csproj	(revision 4041)
+++ /branches/3.2/sources/HeuristicLab.Hive.Server.Console/3.2/HeuristicLab.Hive.Server.Console-3.2.csproj	(revision 4042)
@@ -132,4 +132,14 @@
     </Compile>
     <Compile Include="HiveServerConsolePlugin.cs" />
+    <Compile Include="JobDataFetcher.cs" />
+    <Compile Include="JobListView.cs">
+      <SubType>Component</SubType>
+    </Compile>
+    <Compile Include="JobListViewControl.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="JobListViewControl.Designer.cs">
+      <DependentUpon>JobListViewControl.cs</DependentUpon>
+    </Compile>
     <Compile Include="LogonDlg.cs">
       <SubType>Form</SubType>
@@ -159,4 +169,10 @@
       <DependentUpon>HiveServerManagementConsole.cs</DependentUpon>
       <SubType>Designer</SubType>
+    </EmbeddedResource>
+    <EmbeddedResource Include="JobListView.resx">
+      <DependentUpon>JobListView.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="JobListViewControl.resx">
+      <DependentUpon>JobListViewControl.cs</DependentUpon>
     </EmbeddedResource>
     <EmbeddedResource Include="LogonDlg.resx">
